# This script will copy necessary content and link it against this template repository

# Copy thesis
cp .\Example.tex ../Thesis.tex

$pthPrefix = (Split-Path -Path $pwd -Leaf)
echo "submodule path was set to:" $pthPrefix
# Adjust {\pthPrefix}{} --> {\pthPrefix}{your/submodule/path/}
$pthPrefixSnippet = "{\pthPrefix}{" + (Split-Path -Path $pwd -Leaf) + "/}"
(Get-Content ../Thesis.tex -Raw) -Replace '{\\pthPrefix}{}', $pthPrefixSnippet | Set-Content ../Thesis.tex
# Adjust \input{{\pthPrefix}lib/titlepage} --> input{your/submodule/path/lib/titlepage} and similar
$pthPrefixSnippet = "{" + $pthPrefix + "/"
(Get-Content ../Thesis.tex -Raw) -Replace '{{\\pthPrefix}', $pthPrefixSnippet | Set-Content ../Thesis.tex

# Make folder structure
mkdir -F ../graphics
mkdir -F ../chapters
mkdir -F ../bib

# Copy glossary
cp ./bib/glossaries.tex ../bib/glossaries.tex

# Copy demo references
cp ./bib/IFT.bib ../bib/IFT.bib

# Copy chapters
cp ./chapters/help.tex ../chapters/help.tex